# Microsoft.OData.Core

The `Microsoft.OData.Core` library is a core component of the `OData .NET libraries`, providing classes to serialize, deserialize and validate OData JSON payloads. It supports OData [`v4` and `v4.01`](https://www.odata.org/documentation/).

This library, implements functionality read and write OData messages (i.e. requests and responses). It reads and writes payloads in OData JSON format. The library exposes, among others, the `ODataMessageReader` and `ODataMessageWriter` classes.

## Installation

You can install the `Microsoft.OData.Core` package via NuGet:

```sh
dotnet add package Microsoft.OData.Core
```

Or via the NuGet Package Manager Console:

```sh
Install-Package Microsoft.OData.Core
```

## Getting Started

### Creating an OData Service

To create an OData service, you can use the `Microsoft.OData.Core` library along with other OData libraries like `Microsoft.OData.Edm` and `Microsoft.OData.Client`.

## Documentation

For more detailed information, please refer to the [official documentation](https://learn.microsoft.com/Odata/odatalib/write-payload) or [`OData documentation`](https://learn.microsoft.com/odata)

## Community

### Contribution

There are many ways for you to contribute to [`OData .NET`](https://github.com/OData/odata.net). The easiest way is to participate in discussion of features and issues. You can also contribute by sending pull requests of features or bug fixes to us. Contribution to the documentations is also highly welcomed. Please refer to the [CONTRIBUTING.md](https://github.com/OData/odata.net/blob/main/.github/CONTRIBUTING.md) for more details.

### Reporting Security Issues

Security issues and bugs should be reported privately, via email, to the Microsoft Security Response Center (MSRC) <secure@microsoft.com>. You should receive a response within 24 hours. If for some reason you do not, please follow up via email to ensure we received your original message. Further information, including the MSRC PGP key, can be found in the [Security TechCenter](https://www.microsoft.com/msrc/faqs-report-an-issue).

### 5.3 Support

- **Issues**: Report issues on [Github issues](https://github.com/OData/odata.net/issues).
- **Questions**: Ask questions on [Stack Overflow](http://stackoverflow.com/questions/ask?tags=odata).
- **Feedback**: Please send mails to [odatafeedback@microsoft.com](mailto:odatafeedback@microsoft.com).
- **Team blog**: Please visit [https://devblogs.microsoft.com/odata/](https://devblogs.microsoft.com/odata/) and [http://www.odata.org/blog/](http://www.odata.org/blog/).

### Code of Conduct

This project has adopted the [Microsoft Open Source Code of Conduct](https://opensource.microsoft.com/codeofconduct/). For more information see the [Code of Conduct FAQ](https://opensource.microsoft.com/codeofconduct/faq/) or contact [opencode@microsoft.com](mailto:opencode@microsoft.com) with any additional questions or comments.